VTK: vtkRenderWindowInteractor Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
vtkRenderWindowInteractor Class Reference

platform-independent render window interaction including picking and frame rate control. More...

`#include <vtkRenderWindowInteractor.h>`

Inheritance diagram for vtkRenderWindowInteractor:
[legend]
Collaboration diagram for vtkRenderWindowInteractor:
[legend]

## Public Types
enum | { OneShotTimer = 1 , RepeatingTimer }
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkRenderWindowInteractor * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | UnRegister (vtkObjectBase *o) override
| This Method detects loops of RenderWindow-Interactor, so objects are freed properly. More...
virtual void | Start ()
| Start the event loop. More...
virtual void | ProcessEvents ()
| Process all user-interaction, timer events and return. More...
virtual bool | GetDone ()
| Is the interactor loop done. More...
virtual void | SetDone (bool)
virtual void | Enable ()
| Enable/Disable interactions. More...
virtual void | Disable ()
virtual int | GetEnabled ()
virtual void | UpdateSize (int x, int y)
| Event loop notification member for window size change. More...
virtual int | CreateTimer (int timerType)
| This class provides two groups of methods for manipulating timers. More...
virtual int | DestroyTimer ()
int | CreateRepeatingTimer (unsigned long duration)
| Create a repeating timer, with the specified duration (in milliseconds). More...
int | CreateOneShotTimer (unsigned long duration)
| Create a one shot timer, with the specified duration (in milliseconds). More...
int | IsOneShotTimer (int timerId)
| Query whether the specified timerId is a one shot timer. More...
unsigned long | GetTimerDuration (int timerId)
| Get the duration (in milliseconds) for the specified timerId. More...
int | ResetTimer (int timerId)
| Reset the specified timer. More...
int | DestroyTimer (int timerId)
| Destroy the timer specified by timerId. More...
virtual int | GetVTKTimerId (int platformTimerId)
| Get the VTK timer ID that corresponds to the supplied platform ID. More...
virtual void | TerminateApp ()
| This function is called on 'q','e' keypress if exitmethod is not specified and should be overridden by platform dependent subclasses to provide a termination procedure if one is required. More...
virtual vtkAbstractPropPicker * | CreateDefaultPicker ()
| Create default picker. More...
virtual void | GetMousePosition (int *x, int *y)
| Get the current position of the mouse. More...
virtual void | Render ()
| Render the scene. More...
virtual int * | GetEventPositions (int pointerIndex)
virtual int * | GetLastEventPositions (int pointerIndex)
virtual void | SetEventPosition (int x, int y, int pointerIndex)
virtual void | SetEventPosition (int pos[2], int pointerIndex)
virtual void | SetEventPositionFlipY (int x, int y, int pointerIndex)
virtual void | SetEventPositionFlipY (int pos[2], int pointerIndex)
virtual vtkRenderer * | FindPokedRenderer (int, int)
| When an event occurs, we must determine which Renderer the event occurred within, since one RenderWindow may contain multiple renderers. More...
vtkObserverMediator * | GetObserverMediator ()
| Return the object used to mediate between vtkInteractorObservers contending for resources. More...
virtual void | Initialize ()
| Prepare for handling events and set the Enabled flag to true. More...
void | ReInitialize ()
| Prepare for handling events and set the Enabled flag to true. More...
virtual void | EnableRenderOn ()
| Enable/Disable whether vtkRenderWindowInteractor::Render() calls this->RenderWindow->Render(). More...
virtual void | EnableRenderOff ()
| Enable/Disable whether vtkRenderWindowInteractor::Render() calls this->RenderWindow->Render(). More...
virtual void | SetEnableRender (bool)
| Enable/Disable whether vtkRenderWindowInteractor::Render() calls this->RenderWindow->Render(). More...
virtual bool | GetEnableRender ()
| Enable/Disable whether vtkRenderWindowInteractor::Render() calls this->RenderWindow->Render(). More...
void | SetRenderWindow (vtkRenderWindow *aren)
| Set/Get the rendering window being controlled by this object. More...
virtual vtkRenderWindow * | GetRenderWindow ()
| Set/Get the rendering window being controlled by this object. More...
void | SetHardwareWindow (vtkHardwareWindow *aren)
| Set/Get the hardware window being controlled by this object. More...
virtual vtkHardwareWindow * | GetHardwareWindow ()
| Set/Get the hardware window being controlled by this object. More...
virtual void | SetTimerDuration (unsigned long)
| Specify the default timer interval (in milliseconds). More...
virtual unsigned long | GetTimerDuration ()
| Specify the default timer interval (in milliseconds). More...
virtual void | SetTimerEventId (int)
| These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent. More...
virtual int | GetTimerEventId ()
| These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent. More...
virtual void | SetTimerEventType (int)
| These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent. More...
virtual int | GetTimerEventType ()
| These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent. More...
virtual void | SetTimerEventDuration (int)
| These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent. More...
virtual int | GetTimerEventDuration ()
| These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent. More...
virtual void | SetTimerEventPlatformId (int)
| These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent. More...
virtual int | GetTimerEventPlatformId ()
| These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent. More...
virtual void | SetInteractorStyle (vtkInteractorObserver *)
| External switching between joystick/trackball/new? modes. More...
virtual vtkInteractorObserver * | GetInteractorStyle ()
| External switching between joystick/trackball/new? modes. More...
virtual void | SetLightFollowCamera (vtkTypeBool)
| Turn on/off the automatic repositioning of lights as the camera moves. More...
virtual vtkTypeBool | GetLightFollowCamera ()
| Turn on/off the automatic repositioning of lights as the camera moves. More...
virtual void | LightFollowCameraOn ()
| Turn on/off the automatic repositioning of lights as the camera moves. More...
virtual void | LightFollowCameraOff ()
| Turn on/off the automatic repositioning of lights as the camera moves. More...
virtual void | SetDesiredUpdateRate (double)
| Set/Get the desired update rate. More...
virtual double | GetDesiredUpdateRate ()
| Set/Get the desired update rate. More...
virtual void | SetStillUpdateRate (double)
| Set/Get the desired update rate when movement has stopped. More...
virtual double | GetStillUpdateRate ()
| Set/Get the desired update rate when movement has stopped. More...
virtual int | GetInitialized ()
| See whether interactor has been initialized yet. More...
virtual void | SetPicker (vtkAbstractPicker *)
| Set/Get the object used to perform pick operations. More...
virtual vtkAbstractPicker * | GetPicker ()
| Set/Get the object used to perform pick operations. More...
virtual void | SetPickingManager (vtkPickingManager *)
| Set the picking manager. More...
virtual vtkPickingManager * | GetPickingManager ()
| Set the picking manager. More...
virtual void | ExitCallback ()
| These methods correspond to the Exit, User and Pick callbacks. More...
virtual void | UserCallback ()
| These methods correspond to the Exit, User and Pick callbacks. More...
virtual void | StartPickCallback ()
| These methods correspond to the Exit, User and Pick callbacks. More...
virtual void | EndPickCallback ()
| These methods correspond to the Exit, User and Pick callbacks. More...
void | HideCursor ()
| Hide or show the mouse cursor, it is nice to be able to hide the default cursor if you want VTK to display a 3D cursor instead. More...
void | ShowCursor ()
| Hide or show the mouse cursor, it is nice to be able to hide the default cursor if you want VTK to display a 3D cursor instead. More...
void | FlyTo (vtkRenderer *ren, double x, double y, double z)
| Given a position x, move the current camera's focal point to x. More...
void | FlyTo (vtkRenderer *ren, double *x)
| Given a position x, move the current camera's focal point to x. More...
void | FlyToImage (vtkRenderer *ren, double x, double y)
| Given a position x, move the current camera's focal point to x. More...
void | FlyToImage (vtkRenderer *ren, double *x)
| Given a position x, move the current camera's focal point to x. More...
virtual void | SetNumberOfFlyFrames (int)
| Set the number of frames to fly to when FlyTo is invoked. More...
virtual int | GetNumberOfFlyFrames ()
| Set the number of frames to fly to when FlyTo is invoked. More...
virtual void | SetDolly (double)
| Set the total Dolly value to use when flying to (FlyTo()) a specified point. More...
virtual double | GetDolly ()
| Set the total Dolly value to use when flying to (FlyTo()) a specified point. More...
virtual int * | GetEventPosition ()
| Set/Get information about the current event. More...
virtual void | GetEventPosition (int &, int &)
| Set/Get information about the current event. More...
virtual void | GetEventPosition (int[2])
| Set/Get information about the current event. More...
virtual int * | GetLastEventPosition ()
| Set/Get information about the current event. More...
virtual void | GetLastEventPosition (int &, int &)
| Set/Get information about the current event. More...
virtual void | GetLastEventPosition (int[2])
| Set/Get information about the current event. More...
virtual void | SetLastEventPosition (int, int)
| Set/Get information about the current event. More...
void | SetLastEventPosition (int[2])
| Set/Get information about the current event. More...
virtual void | SetEventPosition (int x, int y)
| Set/Get information about the current event. More...
virtual void | SetEventPosition (int pos[2])
| Set/Get information about the current event. More...
virtual void | SetEventPositionFlipY (int x, int y)
| Set/Get information about the current event. More...
virtual void | SetEventPositionFlipY (int pos[2])
| Set/Get information about the current event. More...
virtual void | SetAltKey (int)
| Set/get whether alt modifier key was pressed. More...
virtual int | GetAltKey ()
| Set/get whether alt modifier key was pressed. More...
virtual void | SetControlKey (int)
| Set/get whether control modifier key was pressed. More...
virtual int | GetControlKey ()
| Set/get whether control modifier key was pressed. More...
virtual void | SetShiftKey (int)
| Set/get whether shift modifier key was pressed. More...
virtual int | GetShiftKey ()
| Set/get whether shift modifier key was pressed. More...
virtual void | SetKeyCode (char)
| Set/get the key code for the key that was pressed. More...
virtual char | GetKeyCode ()
| Set/get the key code for the key that was pressed. More...
virtual void | SetRepeatCount (int)
| Set/get the repear count for the key or mouse event. More...
virtual int | GetRepeatCount ()
| Set/get the repear count for the key or mouse event. More...
virtual void | SetKeySym (const char *)
| Set/get the key symbol for the key that was pressed. More...
virtual char * | GetKeySym ()
| Set/get the key symbol for the key that was pressed. More...
virtual void | SetPointerIndex (int)
| Set/get the index of the most recent pointer to have an event. More...
virtual int | GetPointerIndex ()
| Set/get the index of the most recent pointer to have an event. More...
void | SetRotation (double rotation)
| Set/get the rotation for the gesture in degrees, update LastRotation. More...
virtual double | GetRotation ()
| Set/get the rotation for the gesture in degrees, update LastRotation. More...
virtual double | GetLastRotation ()
| Set/get the rotation for the gesture in degrees, update LastRotation. More...
void | SetScale (double scale)
| Set/get the scale for the gesture, updates LastScale. More...
virtual double | GetScale ()
| Set/get the scale for the gesture, updates LastScale. More...
virtual double | GetLastScale ()
| Set/get the scale for the gesture, updates LastScale. More...
void | SetTranslation (double val[2])
| Set/get the translation for pan/swipe gestures, update LastTranslation. More...
virtual double * | GetTranslation ()
| Set/get the translation for pan/swipe gestures, update LastTranslation. More...
virtual void | GetTranslation (double &, double &)
| Set/get the translation for pan/swipe gestures, update LastTranslation. More...
virtual void | GetTranslation (double[2])
| Set/get the translation for pan/swipe gestures, update LastTranslation. More...
virtual double * | GetLastTranslation ()
| Set/get the translation for pan/swipe gestures, update LastTranslation. More...
virtual void | GetLastTranslation (double &, double &)
| Set/get the translation for pan/swipe gestures, update LastTranslation. More...
virtual void | GetLastTranslation (double[2])
| Set/get the translation for pan/swipe gestures, update LastTranslation. More...
void | SetEventInformation (int x, int y, int ctrl, int shift, char keycode, int repeatcount, const char *keysym, int pointerIndex)
| Set all the event information in one call. More...
void | SetEventInformation (int x, int y, int ctrl=0, int shift=0, char keycode=0, int repeatcount=0, const char *keysym=nullptr)
| Set all the event information in one call. More...
void | SetEventInformationFlipY (int x, int y, int ctrl, int shift, char keycode, int repeatcount, const char *keysym, int pointerIndex)
| Calls SetEventInformation, but flips the Y based on the current Size[1] value (i.e. More...
void | SetEventInformationFlipY (int x, int y, int ctrl=0, int shift=0, char keycode=0, int repeatcount=0, const char *keysym=nullptr)
| Calls SetEventInformation, but flips the Y based on the current Size[1] value (i.e. More...
void | SetKeyEventInformation (int ctrl=0, int shift=0, char keycode=0, int repeatcount=0, const char *keysym=nullptr)
| Set all the keyboard-related event information in one call. More...
virtual void | SetSize (int, int)
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
void | SetSize (int[2])
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
virtual int * | GetSize ()
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
virtual void | GetSize (int &, int &)
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
virtual void | GetSize (int[2])
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
virtual void | SetEventSize (int, int)
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
void | SetEventSize (int[2])
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
virtual int * | GetEventSize ()
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
virtual void | GetEventSize (int &, int &)
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
virtual void | GetEventSize (int[2])
| This methods sets the Size ivar of the interactor without actually changing the size of the window. More...
virtual void | SetUseTDx (bool)
| Use a 3DConnexion device. More...
virtual bool | GetUseTDx ()
| Use a 3DConnexion device. More...
virtual void | MouseMoveEvent ()
| Fire various events. More...
virtual void | RightButtonPressEvent ()
| Fire various events. More...
virtual void | RightButtonReleaseEvent ()
| Fire various events. More...
virtual void | LeftButtonPressEvent ()
| Fire various events. More...
virtual void | LeftButtonReleaseEvent ()
| Fire various events. More...
virtual void | MiddleButtonPressEvent ()
| Fire various events. More...
virtual void | MiddleButtonReleaseEvent ()
| Fire various events. More...
virtual void | MouseWheelForwardEvent ()
| Fire various events. More...
virtual void | MouseWheelBackwardEvent ()
| Fire various events. More...
virtual void | MouseWheelLeftEvent ()
| Fire various events. More...
virtual void | MouseWheelRightEvent ()
| Fire various events. More...
virtual void | ExposeEvent ()
| Fire various events. More...
virtual void | ConfigureEvent ()
| Fire various events. More...
virtual void | EnterEvent ()
| Fire various events. More...
virtual void | LeaveEvent ()
| Fire various events. More...
virtual void | KeyPressEvent ()
| Fire various events. More...
virtual void | KeyReleaseEvent ()
| Fire various events. More...
virtual void | CharEvent ()
| Fire various events. More...
virtual void | ExitEvent ()
| Fire various events. More...
virtual void | FourthButtonPressEvent ()
| Fire various events. More...
virtual void | FourthButtonReleaseEvent ()
| Fire various events. More...
virtual void | FifthButtonPressEvent ()
| Fire various events. More...
virtual void | FifthButtonReleaseEvent ()
| Fire various events. More...
virtual void | StartPinchEvent ()
| Fire various gesture based events. More...
virtual void | PinchEvent ()
| Fire various gesture based events. More...
virtual void | EndPinchEvent ()
| Fire various gesture based events. More...
virtual void | StartRotateEvent ()
| Fire various gesture based events. More...
virtual void | RotateEvent ()
| Fire various gesture based events. More...
virtual void | EndRotateEvent ()
| Fire various gesture based events. More...
virtual void | StartPanEvent ()
| Fire various gesture based events. More...
virtual void | PanEvent ()
| Fire various gesture based events. More...
virtual void | EndPanEvent ()
| Fire various gesture based events. More...
virtual void | TapEvent ()
| Fire various gesture based events. More...
virtual void | LongTapEvent ()
| Fire various gesture based events. More...
virtual void | SwipeEvent ()
| Fire various gesture based events. More...
virtual void | SetRecognizeGestures (bool)
| Convert multitouch events into gestures. More...
virtual bool | GetRecognizeGestures ()
| Convert multitouch events into gestures. More...
virtual int | GetPointersDownCount ()
| When handling gestures you can query this value to determine how many pointers are down for the gesture this is useful for pan gestures for example. More...
void | ClearContact (size_t contactID)
| Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events. More...
int | GetPointerIndexForContact (size_t contactID)
| Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events. More...
int | GetPointerIndexForExistingContact (size_t contactID)
| Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events. More...
bool | IsPointerIndexSet (int i)
| Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events. More...
void | ClearPointerIndex (int i)
| Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkRenderWindowInteractor * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkRenderWindowInteractor * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkRenderWindowInteractor ()
| ~vtkRenderWindowInteractor () override
virtual vtkPickingManager * | CreateDefaultPickingManager ()
| Create default pickingManager. More...
void | GrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
void | ReleaseFocus ()
virtual void | StartEventLoop ()
| Run the event loop (does not return until TerminateApp is called). More...
virtual void | RecognizeGesture (vtkCommand::EventIds)
virtual int | InternalCreateTimer (int timerId, int timerType, unsigned long duration)
| Internal methods for creating and destroying timers that must be implemented by subclasses. More...
virtual int | InternalDestroyTimer (int platformTimerId)
| Internal methods for creating and destroying timers that must be implemented by subclasses. More...
int | GetCurrentTimerId ()
| Internal methods for creating and destroying timers that must be implemented by subclasses. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkRenderWindow * | RenderWindow
vtkHardwareWindow * | HardwareWindow
vtkSmartPointer< vtkInteractorObserver > | InteractorStyle
vtkAbstractPicker * | Picker
vtkPickingManager * | PickingManager
bool | Done
int | Initialized
int | Enabled
bool | EnableRender
int | Style
vtkTypeBool | LightFollowCamera
int | ActorMode
double | DesiredUpdateRate
double | StillUpdateRate
int | AltKey
int | ControlKey
int | ShiftKey
char | KeyCode
double | Rotation
double | LastRotation
double | Scale
double | LastScale
double | Translation [2]
double | LastTranslation [2]
int | RepeatCount
char * | KeySym
int | EventPosition [2]
int | LastEventPosition [2]
int | EventSize [2]
int | Size [2]
int | TimerEventId
int | TimerEventType
int | TimerEventDuration
int | TimerEventPlatformId
int | EventPositions [VTKI_MAX_POINTERS][2]
int | LastEventPositions [VTKI_MAX_POINTERS][2]
int | PointerIndex
size_t | PointerIndexLookup [VTKI_MAX_POINTERS]
int | NumberOfFlyFrames
double | Dolly
vtkObserverMediator * | ObserverMediator
| Widget mediators are used to resolve contention for cursors and other resources. More...
vtkTimerIdMap * | TimerMap
unsigned long | TimerDuration
int | HandleEventLoop
bool | UseTDx
bool | RecognizeGestures
int | PointersDownCount
int | PointersDown [VTKI_MAX_POINTERS]
int | StartingEventPositions [VTKI_MAX_POINTERS][2]
vtkCommand::EventIds | CurrentGesture
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Friends
class | vtkInteractorEventRecorder
class | vtkInteractorObserver
| These methods allow the interactor to control which events are processed. More...
struct | vtkTimerStruct

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

platform-independent render window interaction including picking and frame rate control.

vtkRenderWindowInteractor provides a platform-independent interaction mechanism for mouse/key/time events. It serves as a base class for platform-dependent implementations that handle routing of mouse/key/timer messages to vtkInteractorObserver and its subclasses. vtkRenderWindowInteractor also provides controls for picking, rendering frame rate, and headlights.

vtkRenderWindowInteractor has changed from previous implementations and now serves only as a shell to hold user preferences and route messages to vtkInteractorStyle. Callbacks are available for many events. Platform specific subclasses should provide methods for manipulating timers, TerminateApp, and an event loop if required via Initialize/Start/Enable/Disable.

Warning
  vtkRenderWindowInteractor routes events through VTK's command/observer design pattern. That is, when vtkRenderWindowInteractor (actually, one of its subclasses) sees a platform-dependent event, it translates this into a VTK event using the InvokeEvent() method. Then any vtkInteractorObservers registered for that event are expected to respond as appropriate.

See also
  vtkInteractorObserver

Events:
  vtkCommand::CharEvent vtkCommand::ConfigureEvent vtkCommand::EndPanEvent vtkCommand::EndPickEvent vtkCommand::EndPinchEvent vtkCommand::EndRotateEvent vtkCommand::EnterEvent vtkCommand::ExitEvent vtkCommand::ExposeEvent vtkCommand::FifthButtonPressEvent vtkCommand::FifthButtonReleaseEvent vtkCommand::FourthButtonPressEvent vtkCommand::FourthButtonReleaseEvent vtkCommand::KeyPressEvent vtkCommand::KeyReleaseEvent vtkCommand::LeaveEvent vtkCommand::LeftButtonPressEvent vtkCommand::LeftButtonReleaseEvent vtkCommand::LongTapEvent vtkCommand::MiddleButtonPressEvent vtkCommand::MiddleButtonReleaseEvent vtkCommand::MouseMoveEvent vtkCommand::MouseWheelBackwardEvent vtkCommand::MouseWheelForwardEvent vtkCommand::MouseWheelLeftEvent vtkCommand::MouseWheelRightEvent vtkCommand::PanEvent vtkCommand::PinchEvent vtkCommand::RenderEvent vtkCommand::RightButtonPressEvent vtkCommand::RightButtonReleaseEvent vtkCommand::RotateEvent vtkCommand::StartEvent vtkCommand::StartPanEvent vtkCommand::StartPickEvent vtkCommand::StartPinchEvent vtkCommand::StartRotateEvent vtkCommand::SwipeEvent vtkCommand::TapEvent vtkCommand::UserEvent

Examples:
  vtkRenderWindowInteractor (Examples)

Online Examples:

Tests:
  vtkRenderWindowInteractor (Tests)

Definition at line 81 of file vtkRenderWindowInteractor.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkRenderWindowInteractor::Superclass

Definition at line 88 of file vtkRenderWindowInteractor.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
OneShotTimer |
RepeatingTimer |

Definition at line 253 of file vtkRenderWindowInteractor.h.

## Constructor & Destructor Documentation

## ◆ vtkRenderWindowInteractor()

vtkRenderWindowInteractor::vtkRenderWindowInteractor | ( |  | ) |
| protected

## ◆ ~vtkRenderWindowInteractor()

vtkRenderWindowInteractor::~vtkRenderWindowInteractor | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkRenderWindowInteractor* vtkRenderWindowInteractor::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkRenderWindowInteractor::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkRenderWindowInteractor::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkZSpaceRenderWindowInteractor, vtkVRRenderWindowInteractor, vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkGenericRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, vtkOpenXRRenderWindowInteractor, vtkOpenVRRenderWindowInteractor, vtkRenderWindowInteractor3D, and QVTKInteractor.

## ◆ SafeDownCast()

static vtkRenderWindowInteractor* vtkRenderWindowInteractor::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkRenderWindowInteractor::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkZSpaceRenderWindowInteractor, vtkVRRenderWindowInteractor, vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkGenericRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, vtkOpenXRRenderWindowInteractor, vtkOpenVRRenderWindowInteractor, vtkRenderWindowInteractor3D, and QVTKInteractor.

## ◆ NewInstance()

vtkRenderWindowInteractor* vtkRenderWindowInteractor::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkRenderWindowInteractor::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkZSpaceRenderWindowInteractor, vtkVRRenderWindowInteractor, vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkGenericRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, vtkOpenXRRenderWindowInteractor, and vtkRenderWindowInteractor3D.

## ◆ Initialize()

virtual void vtkRenderWindowInteractor::Initialize | ( |  | ) |
| virtual

Prepare for handling events and set the Enabled flag to true.

This will be called automatically by Start() if the interactor is not initialized, but it can be called manually if you need to perform any operations between initialization and the start of the event loop.

Reimplemented in vtkVRRenderWindowInteractor, vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, vtkOpenXRRenderWindowInteractor, vtkOpenVRRenderWindowInteractor, and QVTKInteractor.

## ◆ ReInitialize()

void vtkRenderWindowInteractor::ReInitialize | ( |  | ) |
| inline

Prepare for handling events and set the Enabled flag to true.

This will be called automatically by Start() if the interactor is not initialized, but it can be called manually if you need to perform any operations between initialization and the start of the event loop.

Definition at line 100 of file vtkRenderWindowInteractor.h.

## ◆ UnRegister()

void vtkRenderWindowInteractor::UnRegister | ( | vtkObjectBase * | o | ) |
| overridevirtual

This Method detects loops of RenderWindow-Interactor, so objects are freed properly.

Reimplemented from vtkObjectBase.

## ◆ Start()

virtual void vtkRenderWindowInteractor::Start | ( |  | ) |
| virtual

Start the event loop.

This is provided so that you do not have to implement your own event loop. You still can use your own event loop if you want.

Reimplemented in QVTKInteractor.

## ◆ ProcessEvents()

virtual void vtkRenderWindowInteractor::ProcessEvents | ( |  | ) |
| inlinevirtual

Process all user-interaction, timer events and return.

If there are no events, this method returns immediately. This method is implemented only on desktop (macOS, linux, windows) and WebAssembly (SDL2). It is not implemented on iOS and Android platforms.

Reimplemented in vtkZSpaceRenderWindowInteractor, vtkVRRenderWindowInteractor, vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, and vtkCocoaRenderWindowInteractor.

Definition at line 127 of file vtkRenderWindowInteractor.h.

## ◆ GetDone()

virtual bool vtkRenderWindowInteractor::GetDone | ( |  | ) |
| virtual

Is the interactor loop done.

## ◆ SetDone()

virtual void vtkRenderWindowInteractor::SetDone | ( | bool |  | ) |
| virtual

## ◆ Enable()

virtual void vtkRenderWindowInteractor::Enable | ( |  | ) |
| inlinevirtual

Enable/Disable interactions.

By default interactors are enabled when initialized. Initialize() must be called prior to enabling/disabling interaction. These methods are used when a window/widget is being shared by multiple renderers and interactors. This allows a "modal" display where one interactor is active when its data is to be displayed and all other interactors associated with the widget are disabled when their data is not displayed.

Reimplemented in vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, and vtkRenderWindowInteractor3D.

Definition at line 144 of file vtkRenderWindowInteractor.h.

## ◆ Disable()

virtual void vtkRenderWindowInteractor::Disable | ( |  | ) |
| inlinevirtual

Reimplemented in vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, and vtkRenderWindowInteractor3D.

Definition at line 149 of file vtkRenderWindowInteractor.h.

## ◆ GetEnabled()

virtual int vtkRenderWindowInteractor::GetEnabled | ( |  | ) |
| virtual

## ◆ EnableRenderOn()

virtual void vtkRenderWindowInteractor::EnableRenderOn | ( |  | ) |
| virtual

Enable/Disable whether vtkRenderWindowInteractor::Render() calls this->RenderWindow->Render().

## ◆ EnableRenderOff()

virtual void vtkRenderWindowInteractor::EnableRenderOff | ( |  | ) |
| virtual

Enable/Disable whether vtkRenderWindowInteractor::Render() calls this->RenderWindow->Render().

## ◆ SetEnableRender()

virtual void vtkRenderWindowInteractor::SetEnableRender | ( | bool |  | ) |
| virtual

Enable/Disable whether vtkRenderWindowInteractor::Render() calls this->RenderWindow->Render().

## ◆ GetEnableRender()

virtual bool vtkRenderWindowInteractor::GetEnableRender | ( |  | ) |
| virtual

Enable/Disable whether vtkRenderWindowInteractor::Render() calls this->RenderWindow->Render().

## ◆ SetRenderWindow()

void vtkRenderWindowInteractor::SetRenderWindow | ( | vtkRenderWindow * | aren | ) |

Set/Get the rendering window being controlled by this object.

## ◆ GetRenderWindow()

virtual vtkRenderWindow* vtkRenderWindowInteractor::GetRenderWindow | ( |  | ) |
| virtual

Set/Get the rendering window being controlled by this object.

## ◆ SetHardwareWindow()

void vtkRenderWindowInteractor::SetHardwareWindow | ( | vtkHardwareWindow * | aren | ) |

Set/Get the hardware window being controlled by this object.

For opengl the hardware window is not used as the opengl subclasses of RenderWindow provide the functionality.

## ◆ GetHardwareWindow()

virtual vtkHardwareWindow* vtkRenderWindowInteractor::GetHardwareWindow | ( |  | ) |
| virtual

Set/Get the hardware window being controlled by this object.

For opengl the hardware window is not used as the opengl subclasses of RenderWindow provide the functionality.

## ◆ UpdateSize()

virtual void vtkRenderWindowInteractor::UpdateSize | ( | int | x,
|  | int | y
| ) |  |
| virtual

Event loop notification member for window size change.

Window size is measured in pixels.

If the size has changed, this method will fire vtkCommand::WindowResizeEvent.

Reimplemented in vtkXRenderWindowInteractor.

## ◆ CreateTimer()

virtual int vtkRenderWindowInteractor::CreateTimer | ( | int | timerType | ) |
| virtual

This class provides two groups of methods for manipulating timers.

The first group (CreateTimer(timerType) and DestroyTimer()) implicitly use an internal timer id (and are present for backward compatibility). The second group (CreateRepeatingTimer(long),CreateOneShotTimer(long), ResetTimer(int),DestroyTimer(int)) use timer ids so multiple timers can be independently managed. In the first group, the CreateTimer() method takes an argument indicating whether the timer is created the first time (timerType==VTKI_TIMER_FIRST) or whether it is being reset (timerType==VTKI_TIMER_UPDATE). (In initial implementations of VTK this was how one shot and repeating timers were managed.) In the second group, the create methods take a timer duration argument (in milliseconds) and return a timer id. Thus the ResetTimer(timerId) and DestroyTimer(timerId) methods take this timer id and operate on the timer as appropriate. Methods are also available for determining

## ◆ DestroyTimer() [1/2]

virtual int vtkRenderWindowInteractor::DestroyTimer | ( |  | ) |
| virtual

## ◆ CreateRepeatingTimer()

int vtkRenderWindowInteractor::CreateRepeatingTimer | ( | unsigned long | duration | ) |

Create a repeating timer, with the specified duration (in milliseconds).

Returns
  the timer id.

## ◆ CreateOneShotTimer()

int vtkRenderWindowInteractor::CreateOneShotTimer | ( | unsigned long | duration | ) |

Create a one shot timer, with the specified duration (in milliseconds).

Returns
  the timer id.

## ◆ IsOneShotTimer()

int vtkRenderWindowInteractor::IsOneShotTimer | ( | int | timerId | ) |

Query whether the specified timerId is a one shot timer.

Returns
  1 if the timer is a one shot timer.

## ◆ GetTimerDuration() [1/2]

unsigned long vtkRenderWindowInteractor::GetTimerDuration | ( | int | timerId | ) |

Get the duration (in milliseconds) for the specified timerId.

## ◆ ResetTimer()

int vtkRenderWindowInteractor::ResetTimer | ( | int | timerId | ) |

Reset the specified timer.

## ◆ DestroyTimer() [2/2]

int vtkRenderWindowInteractor::DestroyTimer | ( | int | timerId | ) |

Destroy the timer specified by timerId.

Returns
  1 if the timer was destroyed.

## ◆ GetVTKTimerId()

virtual int vtkRenderWindowInteractor::GetVTKTimerId | ( | int | platformTimerId | ) |
| virtual

Get the VTK timer ID that corresponds to the supplied platform ID.

## ◆ SetTimerDuration()

virtual void vtkRenderWindowInteractor::SetTimerDuration | ( | unsigned long |  | ) |
| virtual

Specify the default timer interval (in milliseconds).

(This is used in conjunction with the timer methods described previously, e.g., CreateTimer() uses this value; and CreateRepeatingTimer(duration) and CreateOneShotTimer(duration) use the default value if the parameter "duration" is less than or equal to zero.) Care must be taken when adjusting the timer interval from the default value of 10 milliseconds–it may adversely affect the interactors.

## ◆ GetTimerDuration() [2/2]

virtual unsigned long vtkRenderWindowInteractor::GetTimerDuration | ( |  | ) |
| virtual

Specify the default timer interval (in milliseconds).

(This is used in conjunction with the timer methods described previously, e.g., CreateTimer() uses this value; and CreateRepeatingTimer(duration) and CreateOneShotTimer(duration) use the default value if the parameter "duration" is less than or equal to zero.) Care must be taken when adjusting the timer interval from the default value of 10 milliseconds–it may adversely affect the interactors.

## ◆ SetTimerEventId()

virtual void vtkRenderWindowInteractor::SetTimerEventId | ( | int |  | ) |
| virtual

These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent.

The caller of CreateTimerEvent sets up TimerEventId, TimerEventType and TimerEventDuration. The observer of CreateTimerEvent should set up an appropriate platform specific timer based on those values and set the TimerEventPlatformId before returning. The caller of DestroyTimerEvent sets up TimerEventPlatformId. The observer of DestroyTimerEvent should simply destroy the platform specific timer created by CreateTimerEvent. See vtkGenericRenderWindowInteractor's InternalCreateTimer and InternalDestroyTimer for an example.

## ◆ GetTimerEventId()

virtual int vtkRenderWindowInteractor::GetTimerEventId | ( |  | ) |
| virtual

These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent.

The caller of CreateTimerEvent sets up TimerEventId, TimerEventType and TimerEventDuration. The observer of CreateTimerEvent should set up an appropriate platform specific timer based on those values and set the TimerEventPlatformId before returning. The caller of DestroyTimerEvent sets up TimerEventPlatformId. The observer of DestroyTimerEvent should simply destroy the platform specific timer created by CreateTimerEvent. See vtkGenericRenderWindowInteractor's InternalCreateTimer and InternalDestroyTimer for an example.

## ◆ SetTimerEventType()

virtual void vtkRenderWindowInteractor::SetTimerEventType | ( | int |  | ) |
| virtual

These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent.

The caller of CreateTimerEvent sets up TimerEventId, TimerEventType and TimerEventDuration. The observer of CreateTimerEvent should set up an appropriate platform specific timer based on those values and set the TimerEventPlatformId before returning. The caller of DestroyTimerEvent sets up TimerEventPlatformId. The observer of DestroyTimerEvent should simply destroy the platform specific timer created by CreateTimerEvent. See vtkGenericRenderWindowInteractor's InternalCreateTimer and InternalDestroyTimer for an example.

## ◆ GetTimerEventType()

virtual int vtkRenderWindowInteractor::GetTimerEventType | ( |  | ) |
| virtual

These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent.

The caller of CreateTimerEvent sets up TimerEventId, TimerEventType and TimerEventDuration. The observer of CreateTimerEvent should set up an appropriate platform specific timer based on those values and set the TimerEventPlatformId before returning. The caller of DestroyTimerEvent sets up TimerEventPlatformId. The observer of DestroyTimerEvent should simply destroy the platform specific timer created by CreateTimerEvent. See vtkGenericRenderWindowInteractor's InternalCreateTimer and InternalDestroyTimer for an example.

## ◆ SetTimerEventDuration()

virtual void vtkRenderWindowInteractor::SetTimerEventDuration | ( | int |  | ) |
| virtual

These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent.

The caller of CreateTimerEvent sets up TimerEventId, TimerEventType and TimerEventDuration. The observer of CreateTimerEvent should set up an appropriate platform specific timer based on those values and set the TimerEventPlatformId before returning. The caller of DestroyTimerEvent sets up TimerEventPlatformId. The observer of DestroyTimerEvent should simply destroy the platform specific timer created by CreateTimerEvent. See vtkGenericRenderWindowInteractor's InternalCreateTimer and InternalDestroyTimer for an example.

## ◆ GetTimerEventDuration()

virtual int vtkRenderWindowInteractor::GetTimerEventDuration | ( |  | ) |
| virtual

These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent.

The caller of CreateTimerEvent sets up TimerEventId, TimerEventType and TimerEventDuration. The observer of CreateTimerEvent should set up an appropriate platform specific timer based on those values and set the TimerEventPlatformId before returning. The caller of DestroyTimerEvent sets up TimerEventPlatformId. The observer of DestroyTimerEvent should simply destroy the platform specific timer created by CreateTimerEvent. See vtkGenericRenderWindowInteractor's InternalCreateTimer and InternalDestroyTimer for an example.

## ◆ SetTimerEventPlatformId()

virtual void vtkRenderWindowInteractor::SetTimerEventPlatformId | ( | int |  | ) |
| virtual

These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent.

The caller of CreateTimerEvent sets up TimerEventId, TimerEventType and TimerEventDuration. The observer of CreateTimerEvent should set up an appropriate platform specific timer based on those values and set the TimerEventPlatformId before returning. The caller of DestroyTimerEvent sets up TimerEventPlatformId. The observer of DestroyTimerEvent should simply destroy the platform specific timer created by CreateTimerEvent. See vtkGenericRenderWindowInteractor's InternalCreateTimer and InternalDestroyTimer for an example.

## ◆ GetTimerEventPlatformId()

virtual int vtkRenderWindowInteractor::GetTimerEventPlatformId | ( |  | ) |
| virtual

These methods are used to communicate information about the currently firing CreateTimerEvent or DestroyTimerEvent.

The caller of CreateTimerEvent sets up TimerEventId, TimerEventType and TimerEventDuration. The observer of CreateTimerEvent should set up an appropriate platform specific timer based on those values and set the TimerEventPlatformId before returning. The caller of DestroyTimerEvent sets up TimerEventPlatformId. The observer of DestroyTimerEvent should simply destroy the platform specific timer created by CreateTimerEvent. See vtkGenericRenderWindowInteractor's InternalCreateTimer and InternalDestroyTimer for an example.

## ◆ TerminateApp()

virtual void vtkRenderWindowInteractor::TerminateApp | ( |  | ) |
| inlinevirtual

This function is called on 'q','e' keypress if exitmethod is not specified and should be overridden by platform dependent subclasses to provide a termination procedure if one is required.

Reimplemented in vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, and QVTKInteractor.

Definition at line 301 of file vtkRenderWindowInteractor.h.

## ◆ SetInteractorStyle()

virtual void vtkRenderWindowInteractor::SetInteractorStyle | ( | vtkInteractorObserver * |  | ) |
| virtual

External switching between joystick/trackball/new? modes.

Initial value is a vtkInteractorStyleSwitch object.

## ◆ GetInteractorStyle()

virtual vtkInteractorObserver* vtkRenderWindowInteractor::GetInteractorStyle | ( |  | ) |
| virtual

External switching between joystick/trackball/new? modes.

Initial value is a vtkInteractorStyleSwitch object.

## ◆ SetLightFollowCamera()

virtual void vtkRenderWindowInteractor::SetLightFollowCamera | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off the automatic repositioning of lights as the camera moves.

Default is On.

## ◆ GetLightFollowCamera()

virtual vtkTypeBool vtkRenderWindowInteractor::GetLightFollowCamera | ( |  | ) |
| virtual

Turn on/off the automatic repositioning of lights as the camera moves.

Default is On.

## ◆ LightFollowCameraOn()

virtual void vtkRenderWindowInteractor::LightFollowCameraOn | ( |  | ) |
| virtual

Turn on/off the automatic repositioning of lights as the camera moves.

Default is On.

## ◆ LightFollowCameraOff()

virtual void vtkRenderWindowInteractor::LightFollowCameraOff | ( |  | ) |
| virtual

Turn on/off the automatic repositioning of lights as the camera moves.

Default is On.

## ◆ SetDesiredUpdateRate()

virtual void vtkRenderWindowInteractor::SetDesiredUpdateRate | ( | double |  | ) |
| virtual

Set/Get the desired update rate.

This is used by vtkLODActor's to tell them how quickly they need to render. This update is in effect only when the camera is being rotated, or zoomed. When the interactor is still, the StillUpdateRate is used instead. The default is 15.

## ◆ GetDesiredUpdateRate()

virtual double vtkRenderWindowInteractor::GetDesiredUpdateRate | ( |  | ) |
| virtual

Set/Get the desired update rate.

This is used by vtkLODActor's to tell them how quickly they need to render. This update is in effect only when the camera is being rotated, or zoomed. When the interactor is still, the StillUpdateRate is used instead. The default is 15.

## ◆ SetStillUpdateRate()

virtual void vtkRenderWindowInteractor::SetStillUpdateRate | ( | double |  | ) |
| virtual

Set/Get the desired update rate when movement has stopped.

For the non-still update rate, see the SetDesiredUpdateRate method. The default is 0.0001

## ◆ GetStillUpdateRate()

virtual double vtkRenderWindowInteractor::GetStillUpdateRate | ( |  | ) |
| virtual

Set/Get the desired update rate when movement has stopped.

For the non-still update rate, see the SetDesiredUpdateRate method. The default is 0.0001

## ◆ GetInitialized()

virtual int vtkRenderWindowInteractor::GetInitialized | ( |  | ) |
| virtual

See whether interactor has been initialized yet.

Default is 0.

## ◆ SetPicker()

virtual void vtkRenderWindowInteractor::SetPicker | ( | vtkAbstractPicker * |  | ) |
| virtual

Set/Get the object used to perform pick operations.

In order to pick instances of vtkProp, the picker must be a subclass of vtkAbstractPropPicker, meaning that it can identify a particular instance of vtkProp.

## ◆ GetPicker()

virtual vtkAbstractPicker* vtkRenderWindowInteractor::GetPicker | ( |  | ) |
| virtual

Set/Get the object used to perform pick operations.

In order to pick instances of vtkProp, the picker must be a subclass of vtkAbstractPropPicker, meaning that it can identify a particular instance of vtkProp.

## ◆ CreateDefaultPicker()

virtual vtkAbstractPropPicker* vtkRenderWindowInteractor::CreateDefaultPicker | ( |  | ) |
| virtual

Create default picker.

Used to create one when none is specified. Default is an instance of vtkPropPicker.

## ◆ SetPickingManager()

virtual void vtkRenderWindowInteractor::SetPickingManager | ( | vtkPickingManager * |  | ) |
| virtual

Set the picking manager.

Set/Get the object used to perform operations through the interactor By default, a valid but disabled picking manager is instantiated.

## ◆ GetPickingManager()

virtual vtkPickingManager* vtkRenderWindowInteractor::GetPickingManager | ( |  | ) |
| virtual

Set the picking manager.

Set/Get the object used to perform operations through the interactor By default, a valid but disabled picking manager is instantiated.

## ◆ ExitCallback()

virtual void vtkRenderWindowInteractor::ExitCallback | ( |  | ) |
| virtual

These methods correspond to the Exit, User and Pick callbacks.

They allow for the Style to invoke them.

Reimplemented in vtkVRRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, and vtkZSpaceRenderWindowInteractor.

## ◆ UserCallback()

virtual void vtkRenderWindowInteractor::UserCallback | ( |  | ) |
| virtual

These methods correspond to the Exit, User and Pick callbacks.

They allow for the Style to invoke them.

## ◆ StartPickCallback()

virtual void vtkRenderWindowInteractor::StartPickCallback | ( |  | ) |
| virtual

These methods correspond to the Exit, User and Pick callbacks.

They allow for the Style to invoke them.

## ◆ EndPickCallback()

virtual void vtkRenderWindowInteractor::EndPickCallback | ( |  | ) |
| virtual

These methods correspond to the Exit, User and Pick callbacks.

They allow for the Style to invoke them.

## ◆ GetMousePosition()

virtual void vtkRenderWindowInteractor::GetMousePosition | ( | int * | x,
|  | int * | y
| ) |  |
| inlinevirtual

Get the current position of the mouse.

Reimplemented in vtkXRenderWindowInteractor.

Definition at line 393 of file vtkRenderWindowInteractor.h.

## ◆ HideCursor()

void vtkRenderWindowInteractor::HideCursor | ( |  | ) |

Hide or show the mouse cursor, it is nice to be able to hide the default cursor if you want VTK to display a 3D cursor instead.

## ◆ ShowCursor()

void vtkRenderWindowInteractor::ShowCursor | ( |  | ) |

Hide or show the mouse cursor, it is nice to be able to hide the default cursor if you want VTK to display a 3D cursor instead.

## ◆ Render()

virtual void vtkRenderWindowInteractor::Render | ( |  | ) |
| virtual

Render the scene.

Just pass the render call on to the associated vtkRenderWindow.

## ◆ FlyTo() [1/2]

void vtkRenderWindowInteractor::FlyTo | ( | vtkRenderer * | ren,
|  | double | x,
|  | double | y,
|  | double | z
| ) |  |

Given a position x, move the current camera's focal point to x.

The movement is animated over the number of frames specified in NumberOfFlyFrames. The LOD desired frame rate is used.

## ◆ FlyTo() [2/2]

void vtkRenderWindowInteractor::FlyTo | ( | vtkRenderer * | ren,
|  | double * | x
| ) |  |
| inline

Given a position x, move the current camera's focal point to x.

The movement is animated over the number of frames specified in NumberOfFlyFrames. The LOD desired frame rate is used.

Definition at line 421 of file vtkRenderWindowInteractor.h.

## ◆ FlyToImage() [1/2]

void vtkRenderWindowInteractor::FlyToImage | ( | vtkRenderer * | ren,
|  | double | x,
|  | double | y
| ) |  |

Given a position x, move the current camera's focal point to x.

The movement is animated over the number of frames specified in NumberOfFlyFrames. The LOD desired frame rate is used.

## ◆ FlyToImage() [2/2]

void vtkRenderWindowInteractor::FlyToImage | ( | vtkRenderer * | ren,
|  | double * | x
| ) |  |
| inline

Given a position x, move the current camera's focal point to x.

The movement is animated over the number of frames specified in NumberOfFlyFrames. The LOD desired frame rate is used.

Definition at line 423 of file vtkRenderWindowInteractor.h.

## ◆ SetNumberOfFlyFrames()

virtual void vtkRenderWindowInteractor::SetNumberOfFlyFrames | ( | int |  | ) |
| virtual

Set the number of frames to fly to when FlyTo is invoked.

## ◆ GetNumberOfFlyFrames()

virtual int vtkRenderWindowInteractor::GetNumberOfFlyFrames | ( |  | ) |
| virtual

Set the number of frames to fly to when FlyTo is invoked.

## ◆ SetDolly()

virtual void vtkRenderWindowInteractor::SetDolly | ( | double |  | ) |
| virtual

Set the total Dolly value to use when flying to (FlyTo()) a specified point.

Negative values fly away from the point.

## ◆ GetDolly()

virtual double vtkRenderWindowInteractor::GetDolly | ( |  | ) |
| virtual

Set the total Dolly value to use when flying to (FlyTo()) a specified point.

Negative values fly away from the point.

## ◆ GetEventPosition() [1/3]

virtual int* vtkRenderWindowInteractor::GetEventPosition | ( |  | ) |
| virtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

## ◆ GetEventPosition() [2/3]

virtual void vtkRenderWindowInteractor::GetEventPosition | ( | int & | ,
|  | int & |
| ) |  |
| virtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

## ◆ GetEventPosition() [3/3]

virtual void vtkRenderWindowInteractor::GetEventPosition | ( | int | [2] | ) |
| virtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

## ◆ GetLastEventPosition() [1/3]

virtual int* vtkRenderWindowInteractor::GetLastEventPosition | ( |  | ) |
| virtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

## ◆ GetLastEventPosition() [2/3]

virtual void vtkRenderWindowInteractor::GetLastEventPosition | ( | int & | ,
|  | int & |
| ) |  |
| virtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

## ◆ GetLastEventPosition() [3/3]

virtual void vtkRenderWindowInteractor::GetLastEventPosition | ( | int | [2] | ) |
| virtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

## ◆ SetLastEventPosition() [1/2]

virtual void vtkRenderWindowInteractor::SetLastEventPosition | ( | int | ,
|  | int |
| ) |  |
| virtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

## ◆ SetLastEventPosition() [2/2]

void vtkRenderWindowInteractor::SetLastEventPosition | ( | int | [2] | ) |

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

## ◆ SetEventPosition() [1/4]

virtual void vtkRenderWindowInteractor::SetEventPosition | ( | int | x,
|  | int | y
| ) |  |
| inlinevirtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

Definition at line 455 of file vtkRenderWindowInteractor.h.

## ◆ SetEventPosition() [2/4]

virtual void vtkRenderWindowInteractor::SetEventPosition | ( | int | pos[2] | ) |
| inlinevirtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

Definition at line 469 of file vtkRenderWindowInteractor.h.

## ◆ SetEventPositionFlipY() [1/4]

virtual void vtkRenderWindowInteractor::SetEventPositionFlipY | ( | int | x,
|  | int | y
| ) |  |
| inlinevirtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

Definition at line 470 of file vtkRenderWindowInteractor.h.

## ◆ SetEventPositionFlipY() [2/4]

virtual void vtkRenderWindowInteractor::SetEventPositionFlipY | ( | int | pos[2] | ) |
| inlinevirtual

Set/Get information about the current event.

The current x,y position is in the EventPosition, and the previous event position is in LastEventPosition, updated automatically each time EventPosition is set using its Set() method. Mouse positions are measured in pixels. The other information is about key board input.

Definition at line 474 of file vtkRenderWindowInteractor.h.

## ◆ GetEventPositions()

virtual int* vtkRenderWindowInteractor::GetEventPositions | ( | int | pointerIndex | ) |
| inlinevirtual

Definition at line 477 of file vtkRenderWindowInteractor.h.

## ◆ GetLastEventPositions()

virtual int* vtkRenderWindowInteractor::GetLastEventPositions | ( | int | pointerIndex | ) |
| inlinevirtual

Definition at line 485 of file vtkRenderWindowInteractor.h.

## ◆ SetEventPosition() [3/4]

virtual void vtkRenderWindowInteractor::SetEventPosition | ( | int | x,
|  | int | y,
|  | int | pointerIndex
| ) |  |
| inlinevirtual

Definition at line 493 of file vtkRenderWindowInteractor.h.

## ◆ SetEventPosition() [4/4]

virtual void vtkRenderWindowInteractor::SetEventPosition | ( | int | pos[2],
|  | int | pointerIndex
| ) |  |
| inlinevirtual

Definition at line 519 of file vtkRenderWindowInteractor.h.

## ◆ SetEventPositionFlipY() [3/4]

virtual void vtkRenderWindowInteractor::SetEventPositionFlipY | ( | int | x,
|  | int | y,
|  | int | pointerIndex
| ) |  |
| inlinevirtual

Definition at line 523 of file vtkRenderWindowInteractor.h.

## ◆ SetEventPositionFlipY() [4/4]

virtual void vtkRenderWindowInteractor::SetEventPositionFlipY | ( | int | pos[2],
|  | int | pointerIndex
| ) |  |
| inlinevirtual

Definition at line 527 of file vtkRenderWindowInteractor.h.

## ◆ SetAltKey()

virtual void vtkRenderWindowInteractor::SetAltKey | ( | int |  | ) |
| virtual

Set/get whether alt modifier key was pressed.

## ◆ GetAltKey()

virtual int vtkRenderWindowInteractor::GetAltKey | ( |  | ) |
| virtual

Set/get whether alt modifier key was pressed.

## ◆ SetControlKey()

virtual void vtkRenderWindowInteractor::SetControlKey | ( | int |  | ) |
| virtual

Set/get whether control modifier key was pressed.

## ◆ GetControlKey()

virtual int vtkRenderWindowInteractor::GetControlKey | ( |  | ) |
| virtual

Set/get whether control modifier key was pressed.

## ◆ SetShiftKey()

virtual void vtkRenderWindowInteractor::SetShiftKey | ( | int |  | ) |
| virtual

Set/get whether shift modifier key was pressed.

## ◆ GetShiftKey()

virtual int vtkRenderWindowInteractor::GetShiftKey | ( |  | ) |
| virtual

Set/get whether shift modifier key was pressed.

## ◆ SetKeyCode()

virtual void vtkRenderWindowInteractor::SetKeyCode | ( | char |  | ) |
| virtual

Set/get the key code for the key that was pressed.

## ◆ GetKeyCode()

virtual char vtkRenderWindowInteractor::GetKeyCode | ( |  | ) |
| virtual

Set/get the key code for the key that was pressed.

## ◆ SetRepeatCount()

virtual void vtkRenderWindowInteractor::SetRepeatCount | ( | int |  | ) |
| virtual

Set/get the repear count for the key or mouse event.

This specifies how many times a key has been pressed.

## ◆ GetRepeatCount()

virtual int vtkRenderWindowInteractor::GetRepeatCount | ( |  | ) |
| virtual

Set/get the repear count for the key or mouse event.

This specifies how many times a key has been pressed.

## ◆ SetKeySym()

virtual void vtkRenderWindowInteractor::SetKeySym | ( | const char * |  | ) |
| virtual

Set/get the key symbol for the key that was pressed.

This is the key symbol as defined by the relevant X headers. On X based platforms this corresponds to the installed X server, whereas on other platforms the native key codes are translated into a string representation.

## ◆ GetKeySym()

virtual char* vtkRenderWindowInteractor::GetKeySym | ( |  | ) |
| virtual

Set/get the key symbol for the key that was pressed.

This is the key symbol as defined by the relevant X headers. On X based platforms this corresponds to the installed X server, whereas on other platforms the native key codes are translated into a string representation.

## ◆ SetPointerIndex()

virtual void vtkRenderWindowInteractor::SetPointerIndex | ( | int |  | ) |
| virtual

Set/get the index of the most recent pointer to have an event.

## ◆ GetPointerIndex()

virtual int vtkRenderWindowInteractor::GetPointerIndex | ( |  | ) |
| virtual

Set/get the index of the most recent pointer to have an event.

## ◆ SetRotation()

void vtkRenderWindowInteractor::SetRotation | ( | double | rotation | ) |

Set/get the rotation for the gesture in degrees, update LastRotation.

## ◆ GetRotation()

virtual double vtkRenderWindowInteractor::GetRotation | ( |  | ) |
| virtual

Set/get the rotation for the gesture in degrees, update LastRotation.

## ◆ GetLastRotation()

virtual double vtkRenderWindowInteractor::GetLastRotation | ( |  | ) |
| virtual

Set/get the rotation for the gesture in degrees, update LastRotation.

## ◆ SetScale()

void vtkRenderWindowInteractor::SetScale | ( | double | scale | ) |

Set/get the scale for the gesture, updates LastScale.

## ◆ GetScale()

virtual double vtkRenderWindowInteractor::GetScale | ( |  | ) |
| virtual

Set/get the scale for the gesture, updates LastScale.

## ◆ GetLastScale()

virtual double vtkRenderWindowInteractor::GetLastScale | ( |  | ) |
| virtual

Set/get the scale for the gesture, updates LastScale.

## ◆ SetTranslation()

void vtkRenderWindowInteractor::SetTranslation | ( | double | val[2] | ) |

Set/get the translation for pan/swipe gestures, update LastTranslation.

## ◆ GetTranslation() [1/3]

virtual double* vtkRenderWindowInteractor::GetTranslation | ( |  | ) |
| virtual

Set/get the translation for pan/swipe gestures, update LastTranslation.

## ◆ GetTranslation() [2/3]

virtual void vtkRenderWindowInteractor::GetTranslation | ( | double & | ,
|  | double & |
| ) |  |
| virtual

Set/get the translation for pan/swipe gestures, update LastTranslation.

## ◆ GetTranslation() [3/3]

virtual void vtkRenderWindowInteractor::GetTranslation | ( | double | [2] | ) |
| virtual

Set/get the translation for pan/swipe gestures, update LastTranslation.

## ◆ GetLastTranslation() [1/3]

virtual double* vtkRenderWindowInteractor::GetLastTranslation | ( |  | ) |
| virtual

Set/get the translation for pan/swipe gestures, update LastTranslation.

## ◆ GetLastTranslation() [2/3]

virtual void vtkRenderWindowInteractor::GetLastTranslation | ( | double & | ,
|  | double & |
| ) |  |
| virtual

Set/get the translation for pan/swipe gestures, update LastTranslation.

## ◆ GetLastTranslation() [3/3]

virtual void vtkRenderWindowInteractor::GetLastTranslation | ( | double | [2] | ) |
| virtual

Set/get the translation for pan/swipe gestures, update LastTranslation.

## ◆ SetEventInformation() [1/2]

void vtkRenderWindowInteractor::SetEventInformation | ( | int | x,
|  | int | y,
|  | int | ctrl,
|  | int | shift,
|  | char | keycode,
|  | int | repeatcount,
|  | const char * | keysym,
|  | int | pointerIndex
| ) |  |
| inline

Set all the event information in one call.

Definition at line 623 of file vtkRenderWindowInteractor.h.

## ◆ SetEventInformation() [2/2]

void vtkRenderWindowInteractor::SetEventInformation | ( | int | x,
|  | int | y,
|  | int | ctrl = `0`,
|  | int | shift = `0`,
|  | char | keycode = `0`,
|  | int | repeatcount = `0`,
|  | const char * | keysym = `nullptr`
| ) |  |
| inline

Set all the event information in one call.

Definition at line 638 of file vtkRenderWindowInteractor.h.

## ◆ SetEventInformationFlipY() [1/2]

void vtkRenderWindowInteractor::SetEventInformationFlipY | ( | int | x,
|  | int | y,
|  | int | ctrl,
|  | int | shift,
|  | char | keycode,
|  | int | repeatcount,
|  | const char * | keysym,
|  | int | pointerIndex
| ) |  |
| inline

Calls SetEventInformation, but flips the Y based on the current Size[1] value (i.e.

y = this->Size[1] - y - 1).

Definition at line 650 of file vtkRenderWindowInteractor.h.

## ◆ SetEventInformationFlipY() [2/2]

void vtkRenderWindowInteractor::SetEventInformationFlipY | ( | int | x,
|  | int | y,
|  | int | ctrl = `0`,
|  | int | shift = `0`,
|  | char | keycode = `0`,
|  | int | repeatcount = `0`,
|  | const char * | keysym = `nullptr`
| ) |  |
| inline

Calls SetEventInformation, but flips the Y based on the current Size[1] value (i.e.

y = this->Size[1] - y - 1).

Definition at line 656 of file vtkRenderWindowInteractor.h.

## ◆ SetKeyEventInformation()

void vtkRenderWindowInteractor::SetKeyEventInformation | ( | int | ctrl = `0`,
|  | int | shift = `0`,
|  | char | keycode = `0`,
|  | int | repeatcount = `0`,
|  | const char * | keysym = `nullptr`
| ) |  |
| inline

Set all the keyboard-related event information in one call.

Definition at line 667 of file vtkRenderWindowInteractor.h.

## ◆ SetSize() [1/2]

virtual void vtkRenderWindowInteractor::SetSize | ( | int | ,
|  | int |
| ) |  |
| virtual

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ SetSize() [2/2]

void vtkRenderWindowInteractor::SetSize | ( | int | [2] | ) |

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ GetSize() [1/3]

virtual int* vtkRenderWindowInteractor::GetSize | ( |  | ) |
| virtual

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ GetSize() [2/3]

virtual void vtkRenderWindowInteractor::GetSize | ( | int & | ,
|  | int & |
| ) |  |
| virtual

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ GetSize() [3/3]

virtual void vtkRenderWindowInteractor::GetSize | ( | int | [2] | ) |
| virtual

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ SetEventSize() [1/2]

virtual void vtkRenderWindowInteractor::SetEventSize | ( | int | ,
|  | int |
| ) |  |
| virtual

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ SetEventSize() [2/2]

void vtkRenderWindowInteractor::SetEventSize | ( | int | [2] | ) |

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ GetEventSize() [1/3]

virtual int* vtkRenderWindowInteractor::GetEventSize | ( |  | ) |
| virtual

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ GetEventSize() [2/3]

virtual void vtkRenderWindowInteractor::GetEventSize | ( | int & | ,
|  | int & |
| ) |  |
| virtual

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ GetEventSize() [3/3]

virtual void vtkRenderWindowInteractor::GetEventSize | ( | int | [2] | ) |
| virtual

This methods sets the Size ivar of the interactor without actually changing the size of the window.

Normally application programmers would use UpdateSize if anything. This is useful for letting someone else change the size of the rendering window and just letting the interactor know about the change. The current event width/height (if any) is in EventSize (Expose event, for example). Window size is measured in pixels.

## ◆ FindPokedRenderer()

virtual vtkRenderer* vtkRenderWindowInteractor::FindPokedRenderer | ( | int | ,
|  | int |
| ) |  |
| virtual

When an event occurs, we must determine which Renderer the event occurred within, since one RenderWindow may contain multiple renderers.

## ◆ GetObserverMediator()

vtkObserverMediator* vtkRenderWindowInteractor::GetObserverMediator | ( |  | ) |

Return the object used to mediate between vtkInteractorObservers contending for resources.

Multiple interactor observers will often request different resources (e.g., cursor shape); the mediator uses a strategy to provide the resource based on priority of the observer plus the particular request (default versus non-default cursor shape).

## ◆ SetUseTDx()

virtual void vtkRenderWindowInteractor::SetUseTDx | ( | bool |  | ) |
| virtual

Use a 3DConnexion device.

Initial value is false. If VTK is not build with the TDx option, this is no-op. If VTK is build with the TDx option, and a device is not connected, a warning is emitted. It is must be called before the first Render to be effective, otherwise it is ignored.

## ◆ GetUseTDx()

virtual bool vtkRenderWindowInteractor::GetUseTDx | ( |  | ) |
| virtual

Use a 3DConnexion device.

Initial value is false. If VTK is not build with the TDx option, this is no-op. If VTK is build with the TDx option, and a device is not connected, a warning is emitted. It is must be called before the first Render to be effective, otherwise it is ignored.

## ◆ MouseMoveEvent()

virtual void vtkRenderWindowInteractor::MouseMoveEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ RightButtonPressEvent()

virtual void vtkRenderWindowInteractor::RightButtonPressEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

Reimplemented in vtkRenderWindowInteractor3D.

## ◆ RightButtonReleaseEvent()

virtual void vtkRenderWindowInteractor::RightButtonReleaseEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

Reimplemented in vtkRenderWindowInteractor3D.

## ◆ LeftButtonPressEvent()

virtual void vtkRenderWindowInteractor::LeftButtonPressEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ LeftButtonReleaseEvent()

virtual void vtkRenderWindowInteractor::LeftButtonReleaseEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ MiddleButtonPressEvent()

virtual void vtkRenderWindowInteractor::MiddleButtonPressEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

Reimplemented in vtkRenderWindowInteractor3D.

## ◆ MiddleButtonReleaseEvent()

virtual void vtkRenderWindowInteractor::MiddleButtonReleaseEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

Reimplemented in vtkRenderWindowInteractor3D.

## ◆ MouseWheelForwardEvent()

virtual void vtkRenderWindowInteractor::MouseWheelForwardEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ MouseWheelBackwardEvent()

virtual void vtkRenderWindowInteractor::MouseWheelBackwardEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ MouseWheelLeftEvent()

virtual void vtkRenderWindowInteractor::MouseWheelLeftEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ MouseWheelRightEvent()

virtual void vtkRenderWindowInteractor::MouseWheelRightEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ ExposeEvent()

virtual void vtkRenderWindowInteractor::ExposeEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ ConfigureEvent()

virtual void vtkRenderWindowInteractor::ConfigureEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ EnterEvent()

virtual void vtkRenderWindowInteractor::EnterEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ LeaveEvent()

virtual void vtkRenderWindowInteractor::LeaveEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ KeyPressEvent()

virtual void vtkRenderWindowInteractor::KeyPressEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ KeyReleaseEvent()

virtual void vtkRenderWindowInteractor::KeyReleaseEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ CharEvent()

virtual void vtkRenderWindowInteractor::CharEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ ExitEvent()

virtual void vtkRenderWindowInteractor::ExitEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ FourthButtonPressEvent()

virtual void vtkRenderWindowInteractor::FourthButtonPressEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ FourthButtonReleaseEvent()

virtual void vtkRenderWindowInteractor::FourthButtonReleaseEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ FifthButtonPressEvent()

virtual void vtkRenderWindowInteractor::FifthButtonPressEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ FifthButtonReleaseEvent()

virtual void vtkRenderWindowInteractor::FifthButtonReleaseEvent | ( |  | ) |
| virtual

Fire various events.

SetEventInformation should be called just prior to calling any of these methods. These methods will Invoke the corresponding vtk event.

## ◆ StartPinchEvent()

virtual void vtkRenderWindowInteractor::StartPinchEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ PinchEvent()

virtual void vtkRenderWindowInteractor::PinchEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ EndPinchEvent()

virtual void vtkRenderWindowInteractor::EndPinchEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ StartRotateEvent()

virtual void vtkRenderWindowInteractor::StartRotateEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ RotateEvent()

virtual void vtkRenderWindowInteractor::RotateEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ EndRotateEvent()

virtual void vtkRenderWindowInteractor::EndRotateEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ StartPanEvent()

virtual void vtkRenderWindowInteractor::StartPanEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ PanEvent()

virtual void vtkRenderWindowInteractor::PanEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ EndPanEvent()

virtual void vtkRenderWindowInteractor::EndPanEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ TapEvent()

virtual void vtkRenderWindowInteractor::TapEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ LongTapEvent()

virtual void vtkRenderWindowInteractor::LongTapEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ SwipeEvent()

virtual void vtkRenderWindowInteractor::SwipeEvent | ( |  | ) |
| virtual

Fire various gesture based events.

These methods will Invoke the corresponding vtk event.

## ◆ SetRecognizeGestures()

virtual void vtkRenderWindowInteractor::SetRecognizeGestures | ( | bool |  | ) |
| virtual

Convert multitouch events into gestures.

When this is on (its default) multitouch events received by this interactor will be converted into gestures by VTK. If turned off the raw multitouch events will be passed down.

## ◆ GetRecognizeGestures()

virtual bool vtkRenderWindowInteractor::GetRecognizeGestures | ( |  | ) |
| virtual

Convert multitouch events into gestures.

When this is on (its default) multitouch events received by this interactor will be converted into gestures by VTK. If turned off the raw multitouch events will be passed down.

## ◆ GetPointersDownCount()

virtual int vtkRenderWindowInteractor::GetPointersDownCount | ( |  | ) |
| virtual

When handling gestures you can query this value to determine how many pointers are down for the gesture this is useful for pan gestures for example.

## ◆ ClearContact()

void vtkRenderWindowInteractor::ClearContact | ( | size_t | contactID | ) |

Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events.

We keep an array that maps these system dependent contact ids to our pointer index These functions return -1 if the ID is not found or if there is no more room for contacts

## ◆ GetPointerIndexForContact()

int vtkRenderWindowInteractor::GetPointerIndexForContact | ( | size_t | contactID | ) |

Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events.

We keep an array that maps these system dependent contact ids to our pointer index These functions return -1 if the ID is not found or if there is no more room for contacts

## ◆ GetPointerIndexForExistingContact()

int vtkRenderWindowInteractor::GetPointerIndexForExistingContact | ( | size_t | contactID | ) |

Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events.

We keep an array that maps these system dependent contact ids to our pointer index These functions return -1 if the ID is not found or if there is no more room for contacts

## ◆ IsPointerIndexSet()

bool vtkRenderWindowInteractor::IsPointerIndexSet | ( | int | i | ) |

Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events.

We keep an array that maps these system dependent contact ids to our pointer index These functions return -1 if the ID is not found or if there is no more room for contacts

## ◆ ClearPointerIndex()

void vtkRenderWindowInteractor::ClearPointerIndex | ( | int | i | ) |

Most multitouch systems use persistent contact/pointer ids to track events/motion during multitouch events.

We keep an array that maps these system dependent contact ids to our pointer index These functions return -1 if the ID is not found or if there is no more room for contacts

## ◆ CreateDefaultPickingManager()

virtual vtkPickingManager* vtkRenderWindowInteractor::CreateDefaultPickingManager | ( |  | ) |
| protectedvirtual

Create default pickingManager.

Used to create one when none is specified. Default is an instance of vtkPickingManager.

## ◆ GrabFocus()

void vtkRenderWindowInteractor::GrabFocus | ( | vtkCommand * | mouseEvents,
|  | vtkCommand * | keypressEvents = `nullptr`
| ) |  |
| inlineprotected

Definition at line 884 of file vtkRenderWindowInteractor.h.

## ◆ ReleaseFocus()

void vtkRenderWindowInteractor::ReleaseFocus | ( |  | ) |
| inlineprotected

Definition at line 888 of file vtkRenderWindowInteractor.h.

## ◆ InternalCreateTimer()

virtual int vtkRenderWindowInteractor::InternalCreateTimer | ( | int | timerId,
|  | int | timerType,
|  | unsigned long | duration
| ) |  |
| protectedvirtual

Internal methods for creating and destroying timers that must be implemented by subclasses.

InternalCreateTimer() returns a platform-specific timerId and InternalDestroyTimer() returns non-zero value on success.

Reimplemented in vtkVRRenderWindowInteractor, vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkGenericRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, and QVTKInteractor.

## ◆ InternalDestroyTimer()

virtual int vtkRenderWindowInteractor::InternalDestroyTimer | ( | int | platformTimerId | ) |
| protectedvirtual

Internal methods for creating and destroying timers that must be implemented by subclasses.

InternalCreateTimer() returns a platform-specific timerId and InternalDestroyTimer() returns non-zero value on success.

Reimplemented in vtkVRRenderWindowInteractor, vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkGenericRenderWindowInteractor, vtkCocoaRenderWindowInteractor, vtkAndroidRenderWindowInteractor, and QVTKInteractor.

## ◆ GetCurrentTimerId()

int vtkRenderWindowInteractor::GetCurrentTimerId | ( |  | ) |
| protected

Internal methods for creating and destroying timers that must be implemented by subclasses.

InternalCreateTimer() returns a platform-specific timerId and InternalDestroyTimer() returns non-zero value on success.

## ◆ StartEventLoop()

virtual void vtkRenderWindowInteractor::StartEventLoop | ( |  | ) |
| inlineprotectedvirtual

Run the event loop (does not return until TerminateApp is called).

Reimplemented in vtkZSpaceRenderWindowInteractor, vtkVRRenderWindowInteractor, vtkXRenderWindowInteractor, vtkWin32RenderWindowInteractor, vtkSDL2RenderWindowInteractor, vtkIOSRenderWindowInteractor, vtkCocoaRenderWindowInteractor, and vtkAndroidRenderWindowInteractor.

Definition at line 919 of file vtkRenderWindowInteractor.h.

## ◆ RecognizeGesture()

virtual void vtkRenderWindowInteractor::RecognizeGesture | ( | vtkCommand::EventIds |  | ) |
| protectedvirtual

Reimplemented in vtkRenderWindowInteractor3D.

## Friends And Related Function Documentation

## ◆ vtkInteractorEventRecorder

friend class vtkInteractorEventRecorder
| friend

Definition at line 84 of file vtkRenderWindowInteractor.h.

## ◆ vtkInteractorObserver

friend class vtkInteractorObserver
| friend

These methods allow the interactor to control which events are processed.

When the GrabFocus() method is called, then only events that the supplied vtkCommands have registered are invoked. (This method is typically used by widgets, i.e., subclasses of vtkInteractorObserver, to grab events once an event sequence begins.) Note that the friend declaration is done here to avoid doing so in the superclass vtkObject.

Definition at line 883 of file vtkRenderWindowInteractor.h.

## ◆ vtkTimerStruct

friend struct vtkTimerStruct
| friend

Definition at line 896 of file vtkRenderWindowInteractor.h.

## Member Data Documentation

## ◆ RenderWindow

vtkRenderWindow* vtkRenderWindowInteractor::RenderWindow
| protected

Definition at line 818 of file vtkRenderWindowInteractor.h.

## ◆ HardwareWindow

vtkHardwareWindow* vtkRenderWindowInteractor::HardwareWindow
| protected

Definition at line 819 of file vtkRenderWindowInteractor.h.

## ◆ InteractorStyle

vtkSmartPointer<vtkInteractorObserver> vtkRenderWindowInteractor::InteractorStyle
| protected

Definition at line 820 of file vtkRenderWindowInteractor.h.

## ◆ Picker

vtkAbstractPicker* vtkRenderWindowInteractor::Picker
| protected

Definition at line 823 of file vtkRenderWindowInteractor.h.

## ◆ PickingManager

vtkPickingManager* vtkRenderWindowInteractor::PickingManager
| protected

Definition at line 824 of file vtkRenderWindowInteractor.h.

## ◆ Done

bool vtkRenderWindowInteractor::Done
| protected

Definition at line 826 of file vtkRenderWindowInteractor.h.

## ◆ Initialized

int vtkRenderWindowInteractor::Initialized
| protected

Definition at line 834 of file vtkRenderWindowInteractor.h.

## ◆ Enabled

int vtkRenderWindowInteractor::Enabled
| protected

Definition at line 835 of file vtkRenderWindowInteractor.h.

## ◆ EnableRender

bool vtkRenderWindowInteractor::EnableRender
| protected

Definition at line 836 of file vtkRenderWindowInteractor.h.

## ◆ Style

int vtkRenderWindowInteractor::Style
| protected

Definition at line 837 of file vtkRenderWindowInteractor.h.

## ◆ LightFollowCamera

vtkTypeBool vtkRenderWindowInteractor::LightFollowCamera
| protected

Definition at line 838 of file vtkRenderWindowInteractor.h.

## ◆ ActorMode

int vtkRenderWindowInteractor::ActorMode
| protected

Definition at line 839 of file vtkRenderWindowInteractor.h.

## ◆ DesiredUpdateRate

double vtkRenderWindowInteractor::DesiredUpdateRate
| protected

Definition at line 840 of file vtkRenderWindowInteractor.h.

## ◆ StillUpdateRate

double vtkRenderWindowInteractor::StillUpdateRate
| protected

Definition at line 841 of file vtkRenderWindowInteractor.h.

## ◆ AltKey

int vtkRenderWindowInteractor::AltKey
| protected

Definition at line 844 of file vtkRenderWindowInteractor.h.

## ◆ ControlKey

int vtkRenderWindowInteractor::ControlKey
| protected

Definition at line 845 of file vtkRenderWindowInteractor.h.

## ◆ ShiftKey

int vtkRenderWindowInteractor::ShiftKey
| protected

Definition at line 846 of file vtkRenderWindowInteractor.h.

## ◆ KeyCode

char vtkRenderWindowInteractor::KeyCode
| protected

Definition at line 847 of file vtkRenderWindowInteractor.h.

## ◆ Rotation

double vtkRenderWindowInteractor::Rotation
| protected

Definition at line 848 of file vtkRenderWindowInteractor.h.

## ◆ LastRotation

double vtkRenderWindowInteractor::LastRotation
| protected

Definition at line 849 of file vtkRenderWindowInteractor.h.

## ◆ Scale

double vtkRenderWindowInteractor::Scale
| protected

Definition at line 850 of file vtkRenderWindowInteractor.h.

## ◆ LastScale

double vtkRenderWindowInteractor::LastScale
| protected

Definition at line 851 of file vtkRenderWindowInteractor.h.

## ◆ Translation

double vtkRenderWindowInteractor::Translation[2]
| protected

Definition at line 852 of file vtkRenderWindowInteractor.h.

## ◆ LastTranslation

double vtkRenderWindowInteractor::LastTranslation[2]
| protected

Definition at line 853 of file vtkRenderWindowInteractor.h.

## ◆ RepeatCount

int vtkRenderWindowInteractor::RepeatCount
| protected

Definition at line 854 of file vtkRenderWindowInteractor.h.

## ◆ KeySym

char* vtkRenderWindowInteractor::KeySym
| protected

Definition at line 855 of file vtkRenderWindowInteractor.h.

## ◆ EventPosition

int vtkRenderWindowInteractor::EventPosition[2]
| protected

Definition at line 856 of file vtkRenderWindowInteractor.h.

## ◆ LastEventPosition

int vtkRenderWindowInteractor::LastEventPosition[2]
| protected

Definition at line 857 of file vtkRenderWindowInteractor.h.

## ◆ EventSize

int vtkRenderWindowInteractor::EventSize[2]
| protected

Definition at line 858 of file vtkRenderWindowInteractor.h.

## ◆ Size

int vtkRenderWindowInteractor::Size[2]
| protected

Definition at line 859 of file vtkRenderWindowInteractor.h.

## ◆ TimerEventId

int vtkRenderWindowInteractor::TimerEventId
| protected

Definition at line 860 of file vtkRenderWindowInteractor.h.

## ◆ TimerEventType

int vtkRenderWindowInteractor::TimerEventType
| protected

Definition at line 861 of file vtkRenderWindowInteractor.h.

## ◆ TimerEventDuration

int vtkRenderWindowInteractor::TimerEventDuration
| protected

Definition at line 862 of file vtkRenderWindowInteractor.h.

## ◆ TimerEventPlatformId

int vtkRenderWindowInteractor::TimerEventPlatformId
| protected

Definition at line 863 of file vtkRenderWindowInteractor.h.

## ◆ EventPositions

int vtkRenderWindowInteractor::EventPositions[VTKI_MAX_POINTERS][2]
| protected

Definition at line 865 of file vtkRenderWindowInteractor.h.

## ◆ LastEventPositions

int vtkRenderWindowInteractor::LastEventPositions[VTKI_MAX_POINTERS][2]
| protected

Definition at line 866 of file vtkRenderWindowInteractor.h.

## ◆ PointerIndex

int vtkRenderWindowInteractor::PointerIndex
| protected

Definition at line 867 of file vtkRenderWindowInteractor.h.

## ◆ PointerIndexLookup

size_t vtkRenderWindowInteractor::PointerIndexLookup[VTKI_MAX_POINTERS]
| protected

Definition at line 869 of file vtkRenderWindowInteractor.h.

## ◆ NumberOfFlyFrames

int vtkRenderWindowInteractor::NumberOfFlyFrames
| protected

Definition at line 872 of file vtkRenderWindowInteractor.h.

## ◆ Dolly

double vtkRenderWindowInteractor::Dolly
| protected

Definition at line 873 of file vtkRenderWindowInteractor.h.

## ◆ ObserverMediator

vtkObserverMediator* vtkRenderWindowInteractor::ObserverMediator
| protected

Widget mediators are used to resolve contention for cursors and other resources.

Definition at line 893 of file vtkRenderWindowInteractor.h.

## ◆ TimerMap

vtkTimerIdMap* vtkRenderWindowInteractor::TimerMap
| protected

Definition at line 897 of file vtkRenderWindowInteractor.h.

## ◆ TimerDuration

unsigned long vtkRenderWindowInteractor::TimerDuration
| protected

Definition at line 898 of file vtkRenderWindowInteractor.h.

## ◆ HandleEventLoop

int vtkRenderWindowInteractor::HandleEventLoop
| protected

Definition at line 914 of file vtkRenderWindowInteractor.h.

## ◆ UseTDx

bool vtkRenderWindowInteractor::UseTDx
| protected

Definition at line 921 of file vtkRenderWindowInteractor.h.

## ◆ RecognizeGestures

bool vtkRenderWindowInteractor::RecognizeGestures
| protected

Definition at line 925 of file vtkRenderWindowInteractor.h.

## ◆ PointersDownCount

int vtkRenderWindowInteractor::PointersDownCount
| protected

Definition at line 926 of file vtkRenderWindowInteractor.h.

## ◆ PointersDown

int vtkRenderWindowInteractor::PointersDown[VTKI_MAX_POINTERS]
| protected

Definition at line 927 of file vtkRenderWindowInteractor.h.

## ◆ StartingEventPositions

int vtkRenderWindowInteractor::StartingEventPositions[VTKI_MAX_POINTERS][2]
| protected

Definition at line 929 of file vtkRenderWindowInteractor.h.

## ◆ CurrentGesture

vtkCommand::EventIds vtkRenderWindowInteractor::CurrentGesture
| protected

Definition at line 930 of file vtkRenderWindowInteractor.h.

The documentation for this class was generated from the following file:

- Rendering/Core/vtkRenderWindowInteractor.h